#include "include/sql.h"


char *klist_sql_get(const enum KLIST_SQL sql) {
    switch (sql) {
        case INIT: return
                    "create table if not exists users ("
                    "    id integer primary key,"
                    "    name text not null,"
                    "    local_id integer,   -- if the thing is running locally"
                    "    discord_id integer, -- if logging in via web via discord"
                    "    google_id integer -- if logging in via web via google"
                    ");"
                    "create table if not exists user_lists ("
                    "    id integer primary key,"
                    "    user_id integer not null,"
                    "    list_id integer not null"
                    ");"
                    "create table if not exists lists ("
                    "    id integer primary key,"
                    "    name text not null,"
                    "    desc text"
                    ");"
                    "create table if not exists task_stages ("
                    "    id integer primary key,"
                    "    name text not null,"
                    "    desc text,"
                    "    list_id integer not null,"
                    "    foreign key (list_id) references lists(id)"
                    ");"
                    "-- this currently enables moving tasks _between lists_ (calculated of course)"
                    "create table if not exists tasks ("
                    "    id integer primary key,"
                    "    name text not null,"
                    "    desc text,"
                    "    stage integer not null,"
                    "    due date,"
                    "    due_stage integer, -- more like target stage"
                    "    foreign key (stage) references task_stages(id),"
                    "    foreign key (due_stage) references task_stages(id)"
                    ")";
        case ADD_USER: return "insert into users values (?1, ?2, ?3, ?4)";
        case GET_USER: return "select * from users where id = ?1";
        case GET_USERS: return "select * from users";
        case MOD_USER_NAME: return "update users set name = ?1 where id = ?2";
        case MOD_USER_LOCAL: return "update users set local_id = ?1 where id = ?2";;
        case MOD_USER_DISCORD: return "update users set discord_id = ?1 where id = ?2";
        case MOD_USER_GOOGLE: return "update users set google_id = ?1 where id = ?2";
        case ADD_LIST: return "insert into lists values (?1, ?2)";
        case GET_LIST: return "select * from lists where id = ?1";
        case GET_LISTS: return "select * from lists";
        case MOD_LIST_NAME: return "update lists set name = ?1 where id = ?2";
        case DEL_LIST: return "delete from lists where id = ?1";
        case ADD_STAGE: return "insert into task_stages values (?1, ?2, ?3)";
        case GET_STAGE: return "select * from task_stages where id = ?1";
        case GET_STAGES_FOR_LIST: return "select * from task_stages";
        case DEL_STAGE: return "delete from task_stages where id = ?1";
        case ADD_TASK: return "insert into tasks values (?1, ?2, ?3, ?4, ?5, ?6);";
        case GET_TASK: return "select * from tasks where id = ?1";
        case GET_TASKS: return "select * from tasks;";
        case MOD_TASK_NAME: return "update tasks set name = ?1 where id = ?2";
        case MOD_TASK_DESCRIPTION: return "update tasks set description = ?1 where id = ?2";
        case DEL_TASK: return "delete from tasks where id = ?1";
        case _KLIST_SQL_COUNT: return ";";
    }
    return "";
}
